import ipywidgets as widgets
from ipywidgets import VBox

from lhcsmapi.gui.QuerySaveToCsvModule import QuerySaveToCsvModule
from lhcsmapi.gui.StartEndTimeModule import StartEndTimeModule
from lhcsmapi.gui.metadata.SignalMetadataBrowserModule import SignalMetadataBrowserModule
from lhcsmapi.gui.metadata.SignalPreviewModule import SignalPreviewModule

class MetadataBrowser(object):
    def __init__(self, ldb):
        # StartEndTimeModule
        self.setm = StartEndTimeModule()
        # SignalMetadataBrowserModule
        self.smbm = SignalMetadataBrowserModule()
        # SignalPreviewModule
        self.spm = SignalPreviewModule(get_start_time=self.setm.get_start_time,
                                  get_end_time=self.setm.get_end_time,
                                  get_state=self.smbm.get_state,
                                  ldb=ldb)
        # QuerySaveToCsvModule
        out = widgets.Output()
        self.qstcm = QuerySaveToCsvModule(self.spm.get_signal_list, out)

        self.widget = VBox([self.setm.get_widget(), self.smbm.get_widget(), self.spm.get_widget(), self.qstcm.get_widget()]), out

    def show(self):
        return self.widget