import unittest

from lhcsmapi.gui.pc.RqFgcPmSearchBaseModule import check_quench_presence_around_fqc_timestamp


class TestRqFgcPmSearchBaseModule(unittest.TestCase):
    def test_remove_sources_from_another_circuit(self):
        # arrange
        circuit_type = 'RQ'
        circuit_names = ['RQD.A12', 'RQF.A12']
        source_timestamp_qds = [('16L2', 1544622149598000000), ('16L2', 1544622149600000000),
                                ('16R7', 1544622367136000000), ('16R7', 1544622367138000000)]

        # act
        source_timestamp_qds_filtered_act = check_quench_presence_around_fqc_timestamp(circuit_type, circuit_names[0],
                                                                                       source_timestamp_qds)

        # assert
        source_timestamp_qds_filtered_ref = [('16L2', 1544622149598000000), ('16L2', 1544622149600000000)]

        self.assertListEqual(source_timestamp_qds_filtered_act, source_timestamp_qds_filtered_ref)

