import unittest
from lhcsmapi.reference.Reference import Reference


class TestReference(unittest.TestCase):

    def test_get_quench_heater_reference_discharges_RB(self):

        # arrange
        cell = "A8R1"
        circuit_type = 'RB'

        # act
        ref_discharge_df = Reference.read_quench_heater_reference_discharges(circuit_type)
        timestamp_act = ref_discharge_df[ref_discharge_df["Cell"] == cell]["Timestamp"].values[0]

        # assert
        timestamp_exp = 1417014253613000000
        self.assertEqual(timestamp_exp, timestamp_act)

    def test_get_quench_heater_reference_discharges_RQ(self):

        # arrange
        cell = "16L2"
        circuit_type = 'RQ'



        # act
        ref_discharge_df = Reference.read_quench_heater_reference_discharges(circuit_type)
        timestamp_act = ref_discharge_df[ref_discharge_df["Cell"] == cell]["Timestamp"].values[0]

        # assert
        timestamp_exp = 1417079205409000000
        self.assertEqual(timestamp_exp, timestamp_act)

    def test_get_quench_heater_reference_discharge_RQ(self):

        # arrange
        cell = "16L2"
        circuit_type = 'RQ'

        # act
        timestamp_act = Reference.get_quench_heater_reference_discharge(circuit_type, cell)

        # assert
        timestamp_exp = 1417079205409000000
        self.assertEqual(timestamp_exp, timestamp_act)

